#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "DailyRitualInstance.h"
#include "EDBDScoreTypes.h"
#include "GameplayTagContainer.h"
#include "GameEventData.h"
#include "DedicatedServerHandlerComponent.generated.h"

class AActor;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class DEADBYDAYLIGHT_API UDedicatedServerHandlerComponent : public UActorComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TArray<FDailyRitualInstance> _coreRituals;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TArray<FString> _ownedCharacters;

public:
	UFUNCTION(BlueprintCallable)
	void ReceiveGameEvent(EDBDScoreTypes scoreType, float amount, AActor* instigator, AActor* target);

	UFUNCTION()
	void OnGameEvent(FGameplayTag gameEventType, const FGameEventData& gameEventData);

public:
	UDedicatedServerHandlerComponent();
};

FORCEINLINE uint32 GetTypeHash(const UDedicatedServerHandlerComponent) { return 0; }
